<template>
  <div ref="beginProlongation">
    <div ref="prolongation" v-if="display">
      <transition name="fade" mode="out-in">
        <!--Начало первого этапа-->
        <div v-if="[0].includes($prolongation.state) || $pdl.type === 8 && $pdl.isProlongation !== null">
          <div class="white-block">
            <div class="padding">
              <h3>Информация о продлении займа</h3>
            </div>
            <hr>
            <div class="padding prolongation-info">
              <ul>
                <li>Продление займа не считается просрочкой, поэтому вы не портите свою кредитную историю и сохраняете свой статус Лояльного Клиента.</li>
                <li>Услуга предоставляется бесплатно.</li>
                <li>Продление займа возможно с 5-го дня активного займа.</li>
                <li>Максимальный разовый срок продления займа {{maxDays}} {{$helpers.plural(maxDays, ['календарный день', 'календарных дня', 'календарных дней'])}} - на момент продления займа.</li>
                <li>Для продления займа необходимо оплатить только начисленные проценты.</li>
                <li>В случае возникновения просрочки у вас есть возможность воспользоваться продлением займа только в течение 30 дней.</li>
              </ul>
            </div>
          </div>
          <div class="white-block body-sms-form-prolongation">
            <div class="padding">
              <h3>Выберите срок продления займа</h3>
            </div>
            <hr>
            <div class="padding prolongation-block">
              <div class="warning-block" v-if="$prolongation.info.used >= $prolongation.info.withNoRestrictions">
                Продлить займ на срок больше 2 дней невозможно во исполнение требований ЦБ РФ.
              </div>
              <div class="row">
                <div class="columns six special-center-for-percent">
                  <label for="срок продления">Срок продления (От 1 до {{ maxDays }} дней)</label>

                  <button @click = "prolongationPeriod = prolongationPeriod > 1 ? prolongationPeriod - 1 : 1" class="range "></button>
                  <button @click = "prolongationPeriod = prolongationPeriod < maxDays ? prolongationPeriod + 1 : maxDays" class="range last"></button>

                  <input v-model="prolongationPeriod"
                         v-validate="'between:1,' + maxDays"
                         name="срок продления"
                         placeholder=""
                         type="text"
                         autocomplete="off"
                         :class="getValidateClass('срок продления')"
                  >
                  <validate-message
                          v-show="vErrors.has('срок продления')">
                    {{ vErrors.first('срок продления') }}
                  </validate-message>
                </div>
                <div class="columns six special-height-for-percent">
                  <label for="prolongation-percent">Начислено процентов</label>
                  <input name="prolongation-percent" id="prolongation-percent" placeholder="" :value="$pdl.type === 8 ? depositAmount : $prolongation.percentsSum + ' ₽'" disabled="true" type="text">
                </div>
                <!--<div class="columns four special-height-for-percent">
                  <label for="prolongation-cost">Пени за <span>{{ prolongationPeriod }} {{countDays}}</span></label>
                  <input name="prolongation-cost" id="prolongation-cost" placeholder="" :value="$prolongation.commissions + ' ₽'" disabled="true" type="text">
                </div>-->
              </div>
              <div class="row">
                <div class="columns four in-total">
                  <div class="gray">
                    Проценты по займу
                    <br>
                    <small style="font-size:13px;text-transform: none">начисленные на сегодня</small>
                  </div>
                  <div class="red">Итог</div>
                  <div class="black">{{depositAmount}} ₽</div>
                  <div class="fin">Продление до: <strong>{{ prolongationPeriodToDate }}</strong></div>
                </div>
                <div class="columns eight warning yellow left">
                  <div class="warning__wrapper">
                    <div class="warning__icon"></div>
                    <div class="warning__title">Внимание</div>
                    <div class="warning__text">Обязательно подпишите дополнительное соглашение <strong>в течение 12 часов</strong><span v-if="depositAmount" style="display: inline;margin-bottom: 0;">, затем оплатите услугу продления займа</span>.

                    </div>
                  </div>
                </div>

                <!--<div class="warning-block-text-with-phone">Вводя код подтверждения, вы принимаете <a @click="getSupplementary">условия допсоглашения</a>.</div>-->
              </div>
            </div>
          </div>
          <div class="white-block footer-form-prolongation">
            <div class="padding row">
              <a class="legal-protection__link link blue" @click="$emit('back')" style="text-align: left">Вернуться к займу</a></div>
          </div>

          <div class="row">
            <div class="column short-cutter__container">
              <button @click="createDop"
                      :disabled="addonAgreementButtonState"
                      class="button red"
                      :class="{button_loading: $interface.buttonLoading, block: $interface.isMobile}"
              >
                Сформировать доп. соглашение</button>
            </div>
          </div>
        </div>
      </transition>
      <transition name="fade" mode="out-in">
        <!--После того как нажали кнопку "Сформировать допсоглашение"-->
        <div v-if="$pdl.type === 1 && status === 1 || $pdl.type === 8 && signInstallment" ref="sign">
          <sms-form :prolongation="true"
                    :resendUrl="checkUrl"
                    :timeOut="0"
                    @change="handleSms"
                    ref="signBlock"
                    :placeHolder="false"
                    v-model="$user.smsCode"
                    class="body-sms-form-prolongation"
                    @enter="postSmsCode"
          >
            <template slot="title">
              <h3>Продление займа</h3>
            </template>
            <template slot="'additional-title'">
                <div class="text-for-warning-block">{{ textForWarningBlock }} <b>{{dateOverProlongation}}</b></div>
            </template>
            <template slot="'additional-button'">
              <button class="blue"
                      :disabled="!agree || $store.getters.getButtonLoading"
                      @click="postSmsCode"
                      :class="{button_loading: $store.getters.getButtonLoading}"
              >Подписать</button>
            </template>
            <template slot="agreement">
              <div class="padding ui-checkbox" style="padding:0;">
                <ui-checkbox v-model="agree"></ui-checkbox>
                <p @click="agree = !agree">
                  Вводя код подтверждения, вы принимаете <a class="text-decoration" @click.prevent.stop="getSupplementary">условия доп. соглашения</a>
                </p>
              </div>
            </template>
          </sms-form>
          <div class="white-block footer-form-prolongation">
            <div class="padding row">
              <a class="legal-protection__link link blue" @click="$emit('back')" style="text-align: left">Вернуться к займу</a></div>
          </div>
        </div>
      </transition>
      <success-message></success-message>
      <warning-message></warning-message>
    </div>
  </div>
</template>

<script>
  import Signing from '@/pages/MyLoan/Signing'
  import RangeSlider from '@/components/RangeSlider'
  import GetValidateClass from '@/mixins/Validation/GetValidateClassMixin'
  import { REQUIRED_FIELD, MIN_LENGHT } from '@/components/Validators/CustomVeeValidateMessage'
  import SuccessMessage from '@/components/AuxiliaryWindows/SuccessMessage'
  import WarningMessage from '@/components/AuxiliaryWindows/WarningMessage'
  import ErrorHandleMixin from '@/mixins/ErrorHandleMixin'
  import {errorProlongation} from '@/utils/error/prolongation'
  import SmsForm from '@/components/SmsForm'
  import smsErrors from '@/utils/error_mapper/smsErrors';
  import errorInstallment from '@/utils/error_mapper/installment-loan';

export default {
    name: 'Prolongation',
    inject: ['ActiveLoan'],
    components: {
      Signing,
      RangeSlider,
      SuccessMessage,
      WarningMessage,
      SmsForm
    },
    mixins: [GetValidateClass, ErrorHandleMixin],
    data () {
      return {
        blockToShow: '',
        prolongationSmsCode: '',
        display: true,
        textForWarningBlock: 'Доп.соглашение сформировано, необходимо подписать до ',
        isSignClicked: false,
        isChangePeriodClicked: false,
        prolongationPeriod: 0,
        linkToDopPdf: '',
        maxDaysProlongation: 0,
        agree: true,
        contract: ''
      }
    },
    computed: {
      depositAmount () {
        if (this.$pdl.type === 8 && this.$pdl.isProlongation !== null) {
          let amount = this.$pdl.schedule[0].amountLoan * (this.prolongationPeriod * this.$pdl.isProlongation.dailyPercent / 100);
          return parseFloat(amount.toFixed(2));
        }
        if (this.$pdl.supplementary.prolongation && [1,2].includes(this.$pdl.supplementary.prolongation.status)) {
          return this.$pdl.supplementary.prolongation.depositAmount;
        } else {
          return this.$prolongation.percentsSum;
        }
      },

      status () {
        return this.$prolongation.state;
      },
      signInstallment () {
        if (this.$pdl.supplementary.prolongation && this.$pdl.supplementary.prolongation.status === 0) {
          return true;
        }
        return false;
      },
      addonAgreementButtonState () {
        return this.vErrors.any() || this.$interface.buttonLoading
      },
      dateOverProlongation () {
        if (this.$pdl.supplementary.prolongation) {
          return this.$dayjs(this.$pdl.supplementary.prolongation.signDateEnd).format('DD.MM.YYYY (HH:mm:ss)')
        }

        return ''
      },
      maxDays () {
        return this.maxDaysProlongation
      },
      maxDaysInInstallment () {
        if (this.$pdl.isProlongation !== null) {
          return this.$pdl.isProlongation.maxDays
        } else {
          return 0;
        }
      },
      checkUrl () {
        return this.$pdl.type === 8 ? 'installment-loan/prolongation/sign/resend' : this.$backend.api.supplementary.prolongation.resendUrl;
      },
      newRate () {
        return this.$pdl.type === 8 ? parseFloat((this.$pdl.isProlongation.dailyPercent).toFixed(2)) : this.$prolongation.percents[this.prolongationPeriod - 1]
      },
      prolongationPeriodToDate() {

        switch (this.$pdl.type) {
          // @refactor
          case 8:
            const planDate = new Date(this.$pdl.schedule[0].date);
            return new Date(
                    new Date(planDate).setDate(planDate.getDate() + Number(this.prolongationPeriod))).toLocaleString(
                    'ru', {
                      day: 'numeric',
                      month: 'long',
                      year: 'numeric',
                    });
          default:

            if (this.$prolongation.startAt) {
              const [d, m, y] = this.$prolongation.startAt.split('.');
              const date = new Date(y, parseInt(m) - 1, d);
              const dateEnd = this.$dayjs(date).add(this.prolongationPeriod - 1, 'day');

              return dateEnd.format('DD') + ' ' + this.$helpers.ruMonthName(dateEnd.format('MM')) + ' ' +
                      dateEnd.format('YYYY');
            }

            const fromDate = this.$pdl.overdue ? new Date() : this.$pdl.supplementary.loanNewDateEnd ||
                    this.$pdl.dateTo;
            const date = this.$dayjs(new Date(fromDate)).add(this.prolongationPeriod, 'day');

            return date.format('DD') + ' ' + this.$helpers.ruMonthName(date.format('MM')) + ' ' + date.format('YYYY');

        }
      }
    },
    async created () {
      this.loadData()
    },
    mounted () {
      this.$validator.localize(REQUIRED_FIELD);
      this.$validator.localize(MIN_LENGHT);
      window.Analityc.prolongation_info();

    },
    methods: {
      handleSms (sms) {
        this.prolongationSmsCode = sms
      },
      /**
       * Определенные данных.
       * Если нужно обновить данные с бека, то signing = true
       * @param {boolean} signing
       * @returns {Promise<void>}
       */
      async loadData (signing = false) {
        // обновляем данные с сервера если нужно
        if (signing) {
          const promises = [];
          promises.push(this.$store.dispatch('GET_LOAN_PDL'));
          promises.push(this.$store.dispatch('GET_PROLONGATION_DATA'));
          await Promise.all(promises);
          if (this.status === 1) {
            this.$toastr.success('Доп.соглашение сформировано. Введите код отправленный на Ваш телефон для его подписания.', 'Успешно');
            this.$nextTick(() => {
              this.$helpers.scroll(this.$refs.beginProlongation.$el);
              this.$refs.smsCode.focus();
            })
          }
        }

        // определяем переменные
        this.prolongationPeriod = this.$pdl.type === 8 ? this.maxDaysInInstallment : this.$prolongation?.percents?.length;
        this.maxDaysProlongation = this.$pdl.type === 8 ? this.maxDaysInInstallment : this.$prolongation?.percents?.length;

        this.$nextTick(() => {
          if (this.status) {
            this.$backend.api.documents.supplementary.last(this.$pdl.id).then((response) => {
              this.contract = response.data;
            }).catch((e) => {
                console.warn(e);
            })
          }
        })

      },
      async createDop () {
          this.BUTTON_LOADING(true);
          this.AJAX_LOADING(true);
          if (this.$pdl.type === 8) {
            this.$backend.api.installment.prolongation.create(this.prolongationPeriod).then(async () => {
              window.Analityc.prolongaction_create();
              this.$backend.log({
                action: 'createProlongation',
                userid: this.$user.id,
                userlogin: this.$user.login,
              })
              await this.loadData(true)
            }).catch((error) => {
              console.warn('catch error', error)
              this.$error(error, errorInstallment, 'Ошибка на сервере. Попробуйте повторить запрос позднее')
            }).finally(() => {
              this.BUTTON_LOADING(false);
              this.AJAX_LOADING(false);
            })
          } else {
            this.$backend.api.supplementary.prolongation.create({
              daysDuration: this.prolongationPeriod
            }).then(async () => {
              this.$backend.log({
                action: 'createProlongation',
                userid: this.$user.id,
                userlogin: this.$user.login,
              })
              await this.loadData(true)
            }).catch((error) => {
              console.warn('catch error', error)
              // errorProlongation(error.errors[0].code, this.$store)
              this.$toastr.error(error.errors[0].code, 'Ошибка');
            }).finally(() => {
              this.BUTTON_LOADING(false);
              this.AJAX_LOADING(false);
            })
          }
      },
      slidePeriodSlider ({target}) {
        this.prolongationPeriod = target.value
      },
      checkLengthCode () {
        // this.prolongationSmsCode.length === 4 ? this.agree = false : this.agree = true
      },
      async postSmsCode () {
        if (!this.agree) {
          this.$toastr.error('Вы должны принять условия доп. соглашения', 'Ошибка')
          return
        }
        this.$store.commit('AJAX_LOADING', true)
        if (this.$pdl.type === 8) {
          this.$backend.api.prolongation.sign(String(this.prolongationSmsCode)).then(async () => {
            this.$toastr.success(`Доп.соглашение успешно подписано. Плановая дата платежа ${this.$dayjs(this.$pdl.supplementary.prolongation.loanDateEnd).format('DD.MM.YYYY')}. Сумма к оплате ${this.$pdl.supplementary.prolongation.depositAmount} рублей.`, 'Успешно')
            this.$nextTick(() => {
              this.$helpers.scroll(this.$parent.$el);
              this.$pdl.supplementary.prolongation.status = 1
            })
          }).catch((e) => {
            this.$error(e, errorInstallment, 'Ошибка подписания доп.соглашения');
            this.$backend.log({
              action: 'prolongationSignError',
              user_id: this.$user.id,
              user_login: this.$user.login,
              error: Array.isArray(e.errors) ? JSON.stringify(e.errors) : e
            });
          }).finally(() => {
            this.$store.commit('AJAX_LOADING', false)
          })
        } else {
          this.$backend.api.supplementary.prolongation.sign({
            smsCode: Number(this.prolongationSmsCode)
          }).then(async () => {
            const payText = this.$pdl.supplementary.prolongation.depositAmount ? 'Для продления займа необходимо оплатить начисленные проценты, чтобы услуга продления займа вступила в силу.' : '';
            this.$toastr.success('Доп.соглашение успешно подписано. ' + payText, 'Успешно')

            this.$backend.log({
              action: 'prolongationSign',
              user_id: this.$user.id,
              user_login: this.$user.login,
            });

            window.Analityc.prolongation_sign();

            const promises = []
            promises.push(this.$store.dispatch('GET_PROLONGATION_DATA'));
            promises.push(this.$store.dispatch('GET_LOAN_PDL'));
            if (this.$pdl.supplementary.prolongation.depositAmount) {
              return Promise.all(promises).then(() => {
                this.ActiveLoan.payProlongationDeposit();
                this.display = false;
                return Promise.resolve()
              }).then(() => {
                this.$store.commit('AJAX_LOADING', false)
              })
            } else {
              // console.log(this.$parent.$refs);
              this.$helpers.scroll(this.$parent.$el);
              return Promise.resolve();
            }
          }).catch((e) => {
            this.$error(e, smsErrors, 'Ошибка подписания доп.соглашения');
            this.$backend.log({
                                action: 'prolongationSignError',
                                user_id: this.$user.id,
                                user_login: this.$user.login,
                                error: Array.isArray(e.errors) ? JSON.stringify(e.errors) : e
                              });

          }).finally(() => {
            this.$store.commit('AJAX_LOADING', false)
          })
        }
      },
      getSupplementary () {
        window
          .open('about:blank', 'target=_blank', 'status=0,title=0,height=600,width=1200,scrollbars=1')
          .document.write(this.contract)
      }
    }
}
</script>


<style scoped lang="scss">
  .columns.two.small {
    min-width: 100px;
  }

  .info {
    strong {
      font-weight: 600;
    }
  }
  .white-block.padding {
    padding: 30px 30px 0px 30px;
  }

  .after-time {
    cursor: pointer;
  }

  @media (min-width: 1300px) and (max-width: 1522px) {
    .special-center-for-percent {
      text-align: center;
    }
    .special-height-for-percent {
      /*padding-top: 19px;*/
      text-align: center;
    }
  }
  .ui-checkbox {
    cursor: pointer;
    font-size:14px;
  }
  @media all and (max-width: 1100px) {
    .short-cutter__container {
      text-align: center;
    }

    .ui-checkbox {
      & p {
        font-size: 13px;
      }
    }
  }
  .footer-form-prolongation {
    margin-top: -46px;
    border-top-left-radius: 0 !important;
    border-top-right-radius: 0 !important;
  }
  .body-sms-form-prolongation{
    border-bottom-left-radius: 0 !important;
    border-bottom-right-radius: 0 !important;
  }
</style>
